# Achtung: Die letzte Zeile der Eingabedatei wird NICHT bearbeitet!

# modus:
#  0    nichts besonderes
#  1    innerhalb eines Strings "..."
#  2    innerhalb eines Zeichens '...'
#  3    ein Zeichen ` gelesen
#  4    innerhalb eines Tokens `...` oder `...'
#  5    innerhalb einer TokenList ``...``
#  6    innerhalb eines Kommentars
# backslash:    Das letzte Zeichen war ein effektiver Backslash.
# quote:
# dq:           Anfuehrungszeichen

# zeile:        eingelesene Zeile
# c:            gerade gelesenes Zeichen
# suppress:     wahr, falls das gelesene Zeichen NICHT ausgegeben werden soll
# translate:    wahr, falls das Zeichen nach Latex uebersetzt werden soll
# out:          sammelt die Zeichen, die ausgegeben werden sollen

# tex_dokumentation:  wahr, falls TeX-Text zwischen dem Code
# tex_kommentar:      wahr, falls Kommentar innerhalb des Codes mit TeX

BEGIN {modus=0
      dq=sprintf("%c",34)
       for (i=0; i<=31; i++) {
	 s=sprintf("%c",i)
	 trtable[s]=""
       }
       for (i=32; i<=126; i++) {
	 s=sprintf("%c",i)
	 trtable[s]=s
       }
       for (i=127; i<=255; i++) {
	 s=sprintf("%c",i)
	 trtable[s]=""
       }
       trtable[dq]="\mlchar{34}"
       trtable["#"]="\mlchar{35}"
       trtable["$"]="\mlchar{36}"
       trtable["%"]="\mlchar{37}"
       trtable["&"]="\mlchar{38}"
       trtable["-"]="\mlchar{45}"
       trtable["<"]="\mlchar{60}"
       trtable[">"]="\mlchar{62}"
       trtable["["]="\mlchar{91}"
       trtable["\\"]="\mlchar{92}"
       trtable["]"]="\mlchar{93}"
       trtable["^"]="\mlchar{94}"
       trtable["_"]="\_"
       trtable["{"]="\mlchar{123}"
       trtable["|"]="\mlchar{124}"
       trtable["}"]="\mlchar{125}"
       trtable["~"]="\mlchar{126}"

       letztzeile=""
       erste_zeile=1
   }
  { zeile=letztezeile
    letztezeile=$0
    j=1
    while (j<=length(letztezeile) && substr(letztezeile,j,1)==" ") j++
    indentpos=j
      
    backslash=0
    out=""
    suppress=0
    onlyspaces=1
    len=length(zeile)
    for (i=1; i <= len; i++) {
      c=substr(zeile,i,1)
      translate=1
      if (modus==0)
      {
 	if (c==dq) modus=1
	else if (c=="'") modus=2
	else if (c=="`") modus=3
        else if (c=="%") {
	  modus=6
	  tex_dokumentation=0
	  tex_kommentar=0
	  if (i==1) {
	    tex_dokumentation=1
	    suppress=1
          }
	  if ((i>1) && (i+1<=len) && (substr(zeile,i+1,1)=="-")) {
	    tex_kommentar=1
	    i++
	  }
	  if (tex_dokumentation == 0) {
	    out=out "\\bcomment{}"
	  }
        } 
	backslash=0
      } else if (modus==1) {
	if (c==dq && !backslash) modus=0
	if (c=="\\") backslash=(1-backslash); else backslash=0
      } else if (modus==2) {
	if (c=="'" && !backslash) modus=0
	if (c=="\\") backslash=(1-backslash); else backslash=0
      } else if (modus==3) {
	if (c=="`") {modus=5; quote=0} else {
	  modus=4
	  if (c=="\\") backslash=1; else backslash=0
	}
      } else if (modus==4) {
	if ((c=="`" || c=="'") && !backslash) modus=0
	if (c=="\\") backslash=(1-backslash); else backslash=0
      } else if (modus==5) {
	if (quote==0 && c=="`" && !backslash) quote=1; else
	if (quote==1 && c=="`") modus=0; else {
          quote=0
	  if (c=="\\") backslash=(1-backslash); else backslash=0
	}
      } else if (modus==6) {
	if (tex_kommentar!=0 || tex_dokumentation!=0)
	  translate=0
	if (c=="%") {
	  modus=0
	  translate=0
	  suppress=tex_dokumentation
	  if (tex_dokumentation == 0) {
	    c=trtable["%"] "\\ecomment{}"
	  }
	} else if (c=="|" && onlyspaces!=0) {
	  suppress=1
        }
      }

      if (i==indentpos && (modus<=5 || tex_dokumentation==0))
        out=out "\\setindent{}"

      if (c==" " && onlyspaces!=0)
        suppress=1

      if (c!=" " && onlyspaces !=0 && (modus<=5 || tex_dokumentation==0))
        out=out "\\goindent{}"

      if (suppress==0) {
        if (translate!=0) 
          out=out trtable[c]
        else
          out=out c
      }
      suppress=0

      if (onlyspaces!=0 && c!=" ") onlyspaces=0
    }
    if (modus<=5 || tex_dokumentation==0)
      out=out "\\nextline{}"
    if (erste_zeile==0)
      print out
    erste_zeile=0
  }
